 /*
*
* Copyright (c) 2005 Sun Microsystems, Inc.
* All rights reserved.
* You may not modify, use, reproduce, or distribute this software except in compliance with the terms
* of the License at: http://developer.sun.com/berkeley_license.html
* Author : Sameer Tyagi, Sun Microsystems s.t@sun.com
* "Realizing Strategies for Document-Based Web Services With JAX-WS 2.0"
*  http://java.sun.com/developer/technicalArticles/xml/jaxrpcpatterns
*/
package com.sun.docbasedwebservices.polyprocessor;

import org.w3c.dom.Node;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMResult;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.ws.Provider;
import javax.xml.ws.Service;

@javax.xml.ws.ServiceMode(value=Service.Mode.PAYLOAD)
@javax.xml.ws.WebServiceProvider(wsdlLocation="WEB-INF/wsdl/POService.wsdl")
public class PurchaseOrderService  implements Provider<Source>  {

    public Source invoke(Source source) {
          try {
				DOMResult dom = new DOMResult();
				Transformer trans = TransformerFactory.newInstance().newTransformer();
				trans.transform(source, dom);
				Node node = dom.getNode();

				printNodeToConsole(node);

				DOMSource src = new DOMSource (node);
				return src;

          } catch(Exception e) {
              e.printStackTrace();
              throw new RuntimeException("Error in provider endpoint", e);
          }
      }



    public static void printNodeToConsole(Node n) {
        try {
            System.out.println("\n=============================XML Received from Server =========================================");
            TransformerFactory factory = TransformerFactory.newInstance();
            Transformer transformer = factory.newTransformer();
            // also print to console
            transformer.transform(new DOMSource(n), new StreamResult(System.out));
            System.out.println("\n======================================================================");
        } catch (Exception e) {
            System.out.println(e);
        }
    }
}
